#!/usr/bin/perl -w

use strict;

open( INFILE, '<', "myglassware.txt" ) or die "Can't open file \"myglassware.txt\".\n";

my @gw = ( {}, {}, {}, {}, {} );
my @type = ( "Beaker", "Distillation Coil", "Florence Flask", "Test Tube", "Thistle Tube" );

foreach( <INFILE> ) {
   foreach my $t ( 0 .. 4 ) {
      if( (my $qty, my $qual) = /(\d+) $type[$t]:Quality (\d+)/ ) {
         $gw[$t]{$qual} = $qty;
      }
   }
}

close( INFILE );

my @sets = ();

foreach my $beaker ( keys %{$gw[0]} ) {
   foreach my $distcoil ( keys %{$gw[1]} ) {
      foreach my $florence ( keys %{$gw[2]} ) {
         foreach my $testtube ( keys %{$gw[3]} ) {
            foreach my $thistle ( keys %{$gw[4]} ) {
               if( ( ( ($beaker + $distcoil + $florence + $testtube + $thistle) >= 40000 ) &&
                     ( ($beaker + $distcoil + $florence + $testtube + $thistle) < 40005 ) )   ||
                   ( ( ($beaker + $distcoil + $florence + $testtube + $thistle) >= 45000 ) &&
                     ( ($beaker + $distcoil + $florence + $testtube + $thistle) < 45005 ) ) ) {
                  push( @sets, [ $beaker, $distcoil, $florence, $testtube, $thistle ] );
               }
            }
         }
      }
   }
}  

print scalar(@sets) . " total sets found.\n";

my $found = 0;
my $n = @sets;
my @group = ();

until( $found || ($n == 0) ) {
   print "Trying $n...\n";
   @group = ( 0 .. ($n-1) );

   do {
      my @used = ( {}, {}, {}, {}, {} );   
      foreach my $set ( @group ) {
         foreach my $t ( 0 .. 4 ) {
            if( exists $used[$t]{$sets[$set][$t]} ) {
               $used[$t]{$sets[$set][$t]}++;
            } else {
               $used[$t]{$sets[$set][$t]} = 1;
            }
         }
      }
   
      $found = 1;
      foreach my $t ( 0 .. 4 ) {
         foreach my $piece ( keys %{$used[$t]} ) {
            if( $gw[$t]{$piece} < $used[$t]{$piece} ) {
               $found = 0;
            }
         }
      }
      if( $found ) {
         last;
      }

      my $x = $n-1;
      $group[$x]++;
      while( ($group[$x] > (@sets - ($n - $x))) && ($x>0) ) {
         $group[$x-1]++;
         foreach( $x .. ($n-1) ) {
            $group[$_] = $group[$x-1] + ($_ - $x + 1);
         }
         $x--;
      }
      
   } until( $group[0] > (@sets - $n) );

   $n--;
}

print scalar(@group) . " non-conflicting sets found.\n";
foreach my $set ( @group ) {
   foreach my $t ( 0 .. 3 ) {
      print "$type[$t] $sets[$set][$t], ";
   }
   print "$type[4] $sets[$set][4]\n";
}
  
